import type { TSTypeKind, StatementKind } from 'ast-types/lib/gen/kinds';
import * as graphql from 'graphql';
import type { Config } from '../../../lib';
import { TypeWrapper } from '../../../lib';
export declare const fragmentKey: " $fragments";
export declare function inlineType({ config, filepath, rootType, selections, root, allowReadonly, body, visitedTypes, missingScalars, includeFragments, allOptional, forceNonNull, field, }: {
    config: Config;
    filepath: string;
    rootType: graphql.GraphQLNamedType;
    selections: readonly graphql.SelectionNode[] | undefined;
    root: boolean;
    allowReadonly: boolean;
    body: StatementKind[];
    visitedTypes: Set<string>;
    missingScalars: Set<string>;
    includeFragments: boolean;
    field: {
        parent: string;
        field: string;
    } | null;
    allOptional?: boolean;
    forceNonNull?: boolean;
}): TSTypeKind;
export declare function wrapType(wrappers: TypeWrapper[], result: TSTypeKind, root: boolean, forceNullable?: boolean, forceNonNull?: boolean): TSTypeKind;
export declare function selectionTypeInfo(schema: graphql.GraphQLSchema, filepath: string, rootType: graphql.GraphQLObjectType<any, any>, selection: graphql.SelectionNode): {
    field: graphql.GraphQLField<any, any>;
    type: graphql.GraphQLNamedType;
};
