import type { BaseNode } from 'estree-walker';
import * as graphql from 'graphql';
import type { CompiledDocumentKind } from '../runtime/lib/types';
import type { Config } from './config';
import type { Script } from './types';
export type EmbeddedGraphqlDocument = {
    parsedDocument: graphql.DocumentNode;
    artifact: {
        name: string;
        kind: CompiledDocumentKind;
    };
    node: BaseNode & {
        remove: () => void;
        replaceWith: (node: BaseNode) => void;
    };
    tagContent: string;
    parent: BaseNode;
};
type GraphqlTagWalker = {
    skipGraphqlType?: boolean;
    where?: (tag: graphql.DocumentNode, ast: {
        node: BaseNode;
        parent: BaseNode;
    }) => boolean;
    dependency?: (fp: string) => void;
    tag: (tag: EmbeddedGraphqlDocument) => void | Promise<void>;
};
export declare function find_graphql(config: Config, parsedScript: Script, walker: GraphqlTagWalker): Promise<void>;
export {};
