"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var store_exports = {};
__export(store_exports, {
  Writable: () => Writable
});
module.exports = __toCommonJS(store_exports);
const subscriber_queue = [];
const noop = () => {
};
class Writable {
  state;
  #subscribers;
  #stop;
  #start;
  constructor(value, start = noop) {
    this.state = value;
    this.#subscribers = /* @__PURE__ */ new Set();
    this.#stop = null;
    this.#start = start;
  }
  set(new_value) {
    if (safe_not_equal(this.state, new_value)) {
      this.state = new_value;
      if (this.#stop) {
        const run_queue = !subscriber_queue.length;
        for (const subscriber of this.#subscribers) {
          subscriber[1]();
          subscriber_queue.push(subscriber, this.state);
        }
        if (run_queue) {
          for (let i = 0; i < subscriber_queue.length; i += 2) {
            subscriber_queue[i][0](subscriber_queue[i + 1]);
          }
          subscriber_queue.length = 0;
        }
      }
    }
  }
  update(fn) {
    this.set(fn(this.state));
  }
  subscribe(run, invalidate = noop) {
    const subscriber = [run, invalidate];
    this.#subscribers.add(subscriber);
    if (this.#subscribers.size === 1) {
      this.#stop = this.#start(this.set) || noop;
    }
    run(this.state);
    return () => {
      this.#subscribers.delete(subscriber);
      if (this.#subscribers.size === 0) {
        this.#stop?.();
        this.#stop = null;
      }
    };
  }
}
function safe_not_equal(a, b) {
  return a != a ? b == b : a !== b || a && typeof a === "object" || typeof a === "function";
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Writable
});
